////////////////////////////////////////////////////////////////////////////////
/// @brief Ahuacatl, log macros
///
/// @file
///
/// DISCLAIMER
///
/// Copyright 2010-2012 triagens GmbH, Cologne, Germany
///
/// Licensed under the Apache License, Version 2.0 (the "License");
/// you may not use this file except in compliance with the License.
/// You may obtain a copy of the License at
///
///     http://www.apache.org/licenses/LICENSE-2.0
///
/// Unless required by applicable law or agreed to in writing, software
/// distributed under the License is distributed on an "AS IS" BASIS,
/// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
/// See the License for the specific language governing permissions and
/// limitations under the License.
///
/// Copyright holder is triAGENS GmbH, Cologne, Germany
///
/// @author Jan Steemann
/// @author Copyright 2012, triagens GmbH, Cologne, Germany
////////////////////////////////////////////////////////////////////////////////

#ifndef TRIAGENS_DURHAM_AHUACATL_LOG_H
#define TRIAGENS_DURHAM_AHUACATL_LOG_H 1

#include <BasicsC/logging.h> 

#ifdef __cplusplus
extern "C" {
#endif

#undef TRI_DEBUG_AQL  
//#define TRI_DEBUG_AQL 1

// -----------------------------------------------------------------------------
// --SECTION--                                                     public macros
// -----------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
/// @addtogroup Ahuacatl
/// @{
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
/// @brief log debug information to info or trace log
////////////////////////////////////////////////////////////////////////////////

#ifdef TRI_DEBUG_AQL
#define TRI_AQL_LOG(...) LOG_INFO(__VA_ARGS__);
#define TRI_AQL_DUMP(format, ...) printf(format, __VA_ARGS__);
#else
#define TRI_AQL_LOG(...) LOG_TRACE(__VA_ARGS__);
#define TRI_AQL_DUMP(...) { };
#endif

////////////////////////////////////////////////////////////////////////////////
/// @}
////////////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
}
#endif

#endif

// Local Variables:
// mode: outline-minor
// outline-regexp: "^\\(/// @brief\\|/// {@inheritDoc}\\|/// @addtogroup\\|// --SECTION--\\|/// @\\}\\)"
// End:
